# Copyright 2016 Bela Genge
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

'''
OptimalFlow/mod_element/ModElement

@author: Bela Genge
'''

class ModElement(object):
    '''
    '''

    def __init__(self, name):
        '''
        Constructor
        '''
        super(ModElement, self).__init__()
        self.__name = name
        self.__prop = {}


    def setName(self, name):
        self.__name = name


    def setProp(self, prop, name = None):
        self.__prop = prop

        if name is not None:
            self.__name = name


    def getName(self):
        return self.__name


    def getProp(self, idprop):
        return self.__prop[idprop]


    def hasProp(self, prop):
        return prop in self.__prop


    def addProp(self, prop, value):
        self.__prop[prop] = value


