# Copyright 2016 Bela Genge
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

'''
OptimalFlow/mod_link/ModLink

@author: Bela Genge
'''

from mod_element import ModElement

class ModLink(ModElement):
    '''
    '''
    N1 = 'N1'
    N2 = 'N2'
    CAP = 'CAP'
    RCAP = 'RCAP' # Running capacity
    P1 = 'P1' # source port number on the switch
    P2 = 'P2' # destination port number on the switch
    SEC = 'SEC' # Security property
    BKP = 'BKP' # Link type (backup link type)

    def __init__(self, name):
        '''
        Constructor
        '''
        super(ModLink, self).__init__(name)

        self.__secur = []


    # Override version from super class
    def setProp(self, prop, name = None):

        # Store properties
        super(ModLink, self).setProp(prop, name)

        # Set the running capacity to be equal to the preconfigured capacity
        self.addProp(ModLink.RCAP, self.getProp(ModLink.CAP))

    def setSecurProp(self, prop):

        self.__secur = prop

    def getSecurProp(self):

        return self.__secur
