# Copyright 2016 Bela Genge
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

'''
OptimalFlow/mod_solver/ModSolver

@author: Bela Genge
'''

import re
import subprocess

class ModSolver():
    '''
    '''

    def __init__(self, scipPath, fname = './OptimalFlow.lp'):
        '''
        Constructor
        '''
        self.__scipPath = scipPath
        self.__fname = fname


    def solve(self):

        # Run solver
        s = subprocess.check_output([self.__scipPath, "-f", self.__fname])
        #s = subprocess.check_output(["/home/bela/scipoptsuite-3.2.0/scip-3.2.0/bin/scip", "-f", self.__fname])

        # Process result
        sol = []
        for ss in s.split('\n'):
            if re.search('obj:', ss):
                vidx = int(ss.split(' ')[0].split('x')[1])
                sol.append(vidx)

        return sol



